#include "Noeud.h"

// ajout d'une entree dans les exemples restant au niveau de ce noeud
void Noeud::addInStringIndexCounter(const string& str,int index,int numLigne) {
	int i=distribExemples.size()-1;
	while (i>=0 && distribExemples[i].index!=index) i--;
	if (i<0) {
		// alors il faut creer la nouvelle entree
		distribExemples.push_back(StringIndexCounter(str,index,1));
		distribExemples.back().occurrences.push_back(numLigne);
	}
	else {
		distribExemples[i].counter++;
		distribExemples[i].occurrences.push_back(numLigne);
	}
}

// calcul de l'indice de discrimination (attention aux divisions par 0!)
/*** Extension possible:
 *** utiliser une mixture de plusieurs heuristiques au lieu d'une seule;
 *** cela pourrait peut-tre amliorer l'estimation. */
void Noeud::calculateSplitValue(char splitCriteria) {
	int nbTotalExemples=0;
	for (int i=distribExemples.size()-1; i>=0; i--) nbTotalExemples+=distribExemples[i].counter;
	float proportion,maxProp;
	if (nbTotalExemples==0) {
		splitValue=0.0;
		return;
	}

	switch (splitCriteria) {
		case 'g':
			splitValue=1;
			for (int i=distribExemples.size()-1; i>=0; i--)
				splitValue-=square((float)distribExemples[i].counter/nbTotalExemples);
			break;
		case 'e':
			splitValue=0;
			for (int i=distribExemples.size()-1; i>=0; i--) {
				proportion=(float)distribExemples[i].counter/nbTotalExemples;
				splitValue-=proportion*log(proportion);
			}
			break;
		case 'm':
			splitValue=1;
			maxProp=0;
			for (int i=distribExemples.size()-1; i>=0; i--) {
				proportion=(float)distribExemples[i].counter/nbTotalExemples;
				if (proportion>maxProp) maxProp=proportion;
			}
			splitValue-=maxProp;
			break;
		default: break;
	}
}
